///home/berryj/link/bin/genMethods "-t" "Testobj*" "-h" "Array" "-I" "LINK/basic/Array.h" "-I" "LINK/userobj/Testobj.h" "-d" "userobj" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Array.h>

#include <LINK/userobj/Testobj.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ArrayWrapper.h>


typedef Testobj* _Testobj_;
typedef Array<Testobj* > _Array_Testobj__;
static Array<Testobj* > s__Array_Testobj__;

#define _Array_Testobj__DATA(x) ((Array<Testobj* >*) (EXTDATA(x)))
#define _Array_Testobj__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Array<Testobj* > >::type))
#define _Array_Testobj__ISNT_DATA(x) (!_Array_Testobj__IS_DATA(x))

#define _Array_Testobj__CXX_DATA(x) (*(Array<Testobj* >*) (EXTDATA(VAL(x))))
#define _Array_Testobj__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Array<Testobj* > >::type))
#define _Array_Testobj__CXX_ISNT_DATA(x) (!_Array_Testobj__CXX_IS_DATA(x))


PRIMITIVE STk_init__Array_Testobj__()
{
	Wrapper<_Array_Testobj__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Array_Testobj__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ArrayWrapper<_Testobj_>::displayTypedArray,
			(void (*)(SCM x))ArrayWrapper<_Testobj_>::markTypedArray,
			(void (*)(SCM x))ArrayWrapper<_Testobj_>::freeTypedArray);
	Tcl_InitHashTable(&Register<_Array_Testobj__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Array_Testobj__Methods(void);

PRIMITIVE STk_init_methods__Array_Testobj__()
{
	genExtra_Array_Testobj__Methods();
	return UNDEFINED;
}
